/**********************************************
* PIC24FJ32GA002 family 
*  Logger2 : f[^K[vO
*   SW1FOJn/~
*   SW3FOԊu̐ݒ
*     10msec,100msec,500msec,1secԊu@
*   SW2F\
***********************************************/
#include "p24FJ32GA002.h"
#include "FAT16.h"
#include "LCD_Lib3.h"
/// RtBM[V rbg̐ݒ
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF &	BKBUG_OFF
	 & COE_OFF & ICS_PGx1& FWDTEN_OFF ) 
/// 8MHz*PLL4=32MHz (Full Speed)
_CONFIG2( IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD
	 & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE)
/// O[oϐ@///
char BufferA[1024];				// vlꎞۑp_uobt@
char BufferB[1024];
unsigned int Index, Interval, ADData, Number;
char BufAltFlag, BufFill;
unsigned int msec, FileNo;
char sec, minute, hour, day;
/// FATt@Cp\̂̃|C^ϐ
FILE *pointer;	
/// t@Ci[pwb_ƃtb^
const char Header[] 		= "Log Data CH0-3\r\n";// 16word
const char Terminator[] 	= "LogEnd\r\n";		// 8word
/// t\pbZ[WŒf[^
const char MsgStart[] 		= "Start!";
const char MsgEnd[] 		= "Complete End!   ";
const char MsgOpenErr[] 	= "File Open Error ";
const char MsgOpen[] 		= "File Open       ";
const char FileOver[]		= "File Number Over";
const char MsgWriteErr[]	= "Write Error!!   ";
const char MsgSaveEnd[] 	= "Save Completed!!";
const char MsgError[] 		= "!!!Error!!!!    ";
const char MsgHigh[] 		= "Data= +1234.12mV";
const char MsgLow[]			= "1.123V    1.123V";
const char MsgSaveA[]		= "Save Data A!    ";
const char MsgSaveB[]		= "Save Data B!    ";
const char MsgInt[4][17] =
	{{"Set to 10msec   "},{"Set to 100msec  "},
	 {"Set to 500msec  "},{"Set to 1sec     "}};
/// t\pσf[^obt@
char MsgData[] = "xxx,xxx,xxx,xxx ";
char Stump[] = "ddhhmmssmmm,";
/// C^[oύXpPR1ݒl
const int Intval[4] = {625, 6250, 31250, 62500};
/// t@CeLXg
const char FileName[8][12] =
 	{{"LOGGER0.TXT"},{"LOGGER1.TXT"},{"LOGGER2.TXT"},
	 {"LOGGER3.TXT"},{"LOGGER4.TXT"},{"LOGGER5.TXT"},
	 {"LOGGER6.TXT"},{"LOGGER7.TXT"}};
/// vg^CsO
void itostring(char digit, unsigned int data, char *buffer);
unsigned char FileOpen(void);
void toHEX(unsigned int data, char *buffer);
void GetAD(char CH, char *buffer);
void StumpUp(void);

/**************************
* C֐
***************************/
int main(void)
{
	unsigned int  j;
	CLKDIV = 0;
	/// o̓|[gݒ
	TRISA = 0xFFFF;					// |[gAׂ͂ē
	TRISB = 0x038C;					// RB2,3,7,8,9
	CNPU1bits.CN0PUE = 1;				// vAbvL
	CNPU2 = 0x60E1;					// CN21,22,23,(29,30)
	/// SPĨst
	RPINR20bits.SDI1R = 7;				// SDIRP7
	RPOR2bits.RP4R = 8;				// SCK1RP4
	RPOR2bits.RP5R = 7;				// SDO1RP5
	/// ^C}P̏ݒ NbN,1/256,FOSC=16MHz
	PR1 = 6250;						// 100msec^C}
	IPC0bits.T1IP = 5;				// 荞݃x = 5
	T1CON = 0b1000000000110000;		// ^C}P[hݒ
	IFS0bits.T1IF = 0;
	IEC0bits.T1IE = 1;				// 荞݋
	/// ADRo[^̏ݒ
	CMCON = 0;						// Rp[^It
	AD1PCFG = 0xFFCC;					// AN0,1,4,5AiOs 
	AD1CON1 = 0x00E0;					// ADIA蓮TvJn,ϊJn
	AD1CON2 = 0x0000;					// AVdd, AVss, ϊƂɊ荞, MUXÂ
	AD1CON3 = 0x1F05;					// 31 Tad auto-sample, Tad = 5*Tcy
 	AD1CHS  = 0x0000;					// `lIiʂ̂݁j
	AD1CSSL = 0;						// XLȂ
	PORTBbits.RB0 = 1;				// LED0 Off	
	PORTBbits.RB1 = 1;				// LED1 Off	
	/// obt@ƕϐ̏NA
	for(j=0; j<1024; j++) {
		BufferA[j] = 0;				// obt@ANA
		BufferB[j] = 0;				// obt@BNA
	}
	Index = 0;
	BufAltFlag = 0;
	BufFill = 0;
	Interval = 1;
	FileNo = 0;
	/// ^CX^vNA
	msec = 0; sec = 0; minute = 0; hour = 0; day = 0;
	/// JnbZ[W\
	lcd_init();						// LCD
	lcd_clear();						// S
	lcd_str((char*)MsgStart);			// JnbZ[W\
	lcd_cmd(0x80);					// 1sڈړ
	lcd_str("Set to 100msec  ");		// ftHg\

	//////////// C[v@//////////////
	while(1)
	{
		DWORD writeSize;							// FATpϐ
		/// t@Cۑs
		if((BufAltFlag != 0)&&(BufFill == 1))		// obt@tmF
		{	/// obt@t̏ꍇSDJ[hɏo
			if(BufAltFlag == 1)					// obt@BgpH
			{
				writeSize = fwrite((const void*)BufferB, Number, 1, pointer);
				BufFill = 0;
				lcd_cmd(0x80);
				lcd_str((char*)MsgSaveB);			// obt@BobZ[W
			}
			else if(BufAltFlag == 2)				// obt@AgpH
			{
				writeSize = fwrite((const void*)BufferA, Number, 1, pointer);
				BufFill = 0;
				lcd_cmd(0x80);
				lcd_str((char*)MsgSaveA);			// obt@AobZ[W
			}
		}
		/// SW1̏iC^[ȏIj
		if(PORTAbits.RA2 == 0)						// SW1I?
		{
			Interval++;							// C^[olXV
			if(Interval > 3)						// 4ŃTCNbN
				Interval = 0;	
			PR1 = Intval[Interval];				// ^C}1C^[oύX
			lcd_cmd(0x80);						// LCD1sڂɈړ			
			lcd_str((char*)MsgInt[Interval]);		// bZ[W\
			while(PORTAbits.RA2 == 0);				// SW1XCb`It҂
		}
		/// SW3̏it@CۑJn/~j
		if(PORTAbits.RA4 == 0)						// SW3 is On?		
		{
			if(BufAltFlag == 0)					// t@CۑłȂH
			{	/// t@CۑJn
				PORTBbits.RB1 = 0;				// LED1 On
				if(FileOpen() == 0){				// t@CI[v
					/// t@CI[vłꍇ
					lcd_cmd(0x80);				// LCD1sڂ
					lcd_str((char*)MsgOpen);		// I[vbZ[W
					FileNo++;					// t@CAԍXV
					if(FileNo > 7)				// 7܂ŎgH
					{
						FileNo = 0;				// t@CA0ɖ߂
						lcd_cmd(0x80);			// LCD1s
						lcd_str((char*)FileOver);	// t@CAԃI[o[bZ[W
					}
					/// ^CX^vZbg
					msec = 0; sec = 0; minute = 0; hour = 0; day = 0;
					Index = 0;
					/// t@Cwb_
					writeSize =  fwrite((const void*)Header, 16, 1, pointer);
					BufAltFlag = 1;
				}		
				else {		/// t@CI[vG[̏ꍇ 
					lcd_cmd(0x80);
					lcd_str((char*)MsgOpenErr);	// I[vG[bZ[W
					BufAltFlag = 0;					
				}
			}
			else
			{	/// t@Cۑs̏ꍇ́At@Cۑ~
				/// t@Ctb^
				writeSize =  fwrite((const void*)Terminator, 8, 1, pointer);
				fclose(pointer);				// t@CN[Y
				BufAltFlag = 0;					// f[^Zbg
				Index = 0;
				lcd_cmd(0x80);					// 1sڂ
				lcd_str((char*)MsgSaveEnd);		// 폑݊ //
				PORTBbits.RB1 = 1;				// LED1 It
			}
			while(PORTAbits.RA4 == 0);			// SW3It҂							
		}
		delay_ms(50);							// chattering
	}
}
/***********************
* ^C}P荞ݏ֐
***********************/
void  __attribute__((interrupt, no_auto_psv)) _T1Interrupt(void)
{
	int i;
	IFS0bits.T1IF = 0;					// 荞݃tONA
	PORTBbits.RB0 ^= 1;					// LED1_
	if(BufAltFlag != 0)					// ݒH
		StumpUp();						// ^CX^vXV
	/// 4`l̃f[^荞
	GetAD(0, MsgData);
	GetAD(1, MsgData+4);
	GetAD(4, MsgData+8);
	GetAD(5, MsgData+12);
	/// f[^LCD\
	lcd_cmd(0xC0);						// Qsڐ擪w
	lcd_str(MsgData);						// bZ[W\
	/// f[^obt@ɕۑ
	if(BufAltFlag == 1)	{				// obt@AH
		for(i=0; i<12; i++)				// ^CX^vۑ
			BufferA[Index++] = Stump[i];
		for(i=0; i<15; i++)				// f[^ۑ
			BufferA[Index++] = MsgData[i];
		BufferA[Index++] = 0x0D;			// 1ACe؂
		BufferA[Index++] = 0x0A;
	}
	else if(BufAltFlag == 2){				// obt@BH
		for(i=0; i<12; i++)				// ^CX^vۑ
			BufferB[Index++] = Stump[i];
		for(i=0; i<15; i++)				// f[^ۑ
			BufferB[Index++] = MsgData[i];
		BufferB[Index++] = 0x0D;			// 1ACe؂
		BufferB[Index++] = 0x0A;
	}
	/// obt@t`FbNƃobt@؂ւ
	if(Index > 994){						// 1񕪂̗]TcĈt
		Number = Index;					// ŏIlۑ
		BufFill = 1;						// obt@ttOZbg
		Index = 0;						// CfbNXŏɖ߂
		if(BufAltFlag == 1)				// obt@ؑ
			BufAltFlag = 2;
		else if(BufAltFlag ==2)
			BufAltFlag = 1;
	}
}
/*********************************
* t@CI[v֐
**********************************/
unsigned char FileOpen(void)
{
	/// t@C̎҂ƃfBNgǂݍ
	while(!FAT16Init());
	/// t@Ct@CŃI[v܂͐VK
	pointer = fopen(FileName[FileNo], "w");
	Nop();
	if(pointer == NULL)
		return(0xFF);		// I[vG[	
	else
		return(0);			// I[v
}

/***************************************
* ^CX^vXVTu֐
****************************************/
void StumpUp(void)
{
	switch(Interval)			// C^[oZ
	{
		case 0:	msec += 10;	// 10msec
				break;
		case 1: msec += 100;	// 100msec
				break;
		case 2: msec += 500;	// 500msec
				break;
		case 3:	sec++;		// 1sec
				break;
		default:break;
	}
	/// XV
	if(msec >= 1000){			// msecb
		msec -= 1000;
		sec++;
	}
	if(sec >= 60) {
		sec -= 60;			// b番
		minute++;
	}
	if(minute >= 60) {
		minute -= 60;			// 玞Ԃ
		hour++;
	}
	if(hour > 24) {
		hour -= 24;			// Ԃ
		day++;
	}
	if(day >= 30) {
		day = 0;				// ő30
	}
	//// ASCIIɕϊ
	itostring(2, (unsigned int)day, Stump);
	itostring(2, (unsigned int)hour, Stump+2);
	itostring(2, (unsigned int)minute, Stump+4);
	itostring(2, (unsigned int)sec, Stump+6);
	itostring(3, msec, Stump+8);	
}



/***************************************
* A/D ϊsTu֐
****************************************/
void GetAD(char CH, char *buffer)
{
	AD1CON1bits.ADON = 0;			// ADIt	
	AD1CHS = CH;					// `lI
	AD1CON1bits.ADON = 1;			// ADēxI
	AD1CON1bits.SAMP = 1;			// TvOJn
	while(!AD1CON1bits.DONE);		// ϊI҂
	toHEX(ADC1BUF0, buffer);		// JE^lɕϊ
}

/***************************************
* ASCIIɕϊ
****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;
	buffer += digit;					// Ō̐ʒu
	for(i=digit; i>0; i--) {			// ϊ͉ʂʂ
		buffer--;					// |C^[P
		*buffer = (data % 10) + '0';	// ASCII
		data = data / 10;				// ̌
	}
}

/***************************************
* 10rbgoCil316i֕ϊ
****************************************/
void toHEX(unsigned int data, char *buffer)
{
	*buffer = '0' + ((char)(data >> 8) & 0x0F);
	if(((data >> 8) & 0x0F) > 9)
		*buffer += 7;
	buffer++;
	*buffer = '0' + ((char)(data>>4) & 0x0F);
	if(((data>>4) & 0x0F) > 9)
		*buffer += 7;
	*buffer++;
	*buffer = '0' + ((char)data & 0x0F);
	if((data & 0x0F) > 9)
		*buffer += 7;
}

